#include "Gadget/Engine.h"
#include "Particle.h"

//Static variables have to be declaired outside of the class as well
bool   Particle::init = false;
Image  Particle::img;
Core*  Particle::G;

Particle::Particle()//Constructor
{
	timer = 0.0f;

	spr.width  = 100.0f;
	spr.height = 100.0f;
	spr.CenterOrigin(); //Place the origin in the center of the sprite
	spr.rotation = float(rand()%360); //Random rotation
}

void Particle::Init(Core* core)
{
	G = core;

	if(!init)//Make sure we only load the image once
	{
		img.Load("Images/Explode1.jpg");
		init = true;
	}
}

void Particle::Step()
{	
	//Set the sprite position
	spr.x = position.x;
	spr.y = position.y;
	spr.SelectAnimationFrame(2, 4, int(timer));

	//Render the particle
	Shader::Blend(3);
	img.Activate();
	spr.Render();	

	//Update the timer based on the actual amount of time that has passed. In this
	//case, the timer is increasing by 5 each second. I'm using it to control the
	//animation and I want the graphic to animate at 5 frames/second.
	timer += G->Timer.GetElapsedTime()*5.0f;

	//Update the position of the particle
	position += velocity * G->Timer.GetElapsedTime();
}

